diff --git a/src/backend/utils/time/tqual.c b/src/backend/utils/time/tqual.c
index bbac4083c9..bd4fc2ac65 100644
--- a/src/backend/utils/time/tqual.c
+++ b/src/backend/utils/time/tqual.c
@@ -1473,127 +1298,99 @@ HeapTupleIsSurelyDead(HeapTuple htup, TransactionId OldestXmin)
 }
 
 /*
- * XidInMVCCSnapshot
- *		Is the given XID still-in-progress according to the snapshot?
+ * XidVisibleInSnapshot
+ *		Is the given XID visible according to the snapshot?
+ *
+ * If 'known_committed' is true, xid is known to be committed already, even
+ * though it might not be visible to the snapshot. Passing 'true' can save
+ * some cycles.
  *
- * Note: GetSnapshotData never stores either top xid or subxids of our own
- * backend into a snapshot, so these xids will not be reported as "running"
- * by this function.  This is OK for current uses, because we always check
- * TransactionIdIsCurrentTransactionId first, except for known-committed
- * XIDs which could not be ours anyway.
+ * On return, *hintstatus is set to indicate if the transaction had committed,
+ * or aborted, whether or not it's not visible to us.
  */
 static bool
-XidInMVCCSnapshot(TransactionId xid, Snapshot snapshot)
+XidVisibleInSnapshot(TransactionId xid, Snapshot snapshot,
+					 TransactionIdStatus *hintstatus)
 {
-	uint32		i;
+	CommitSeqNo csn;
 
-	/*
-	 * Make a quick range check to eliminate most XIDs without looking at the
-	 * xip arrays.  Note that this is OK even if we convert a subxact XID to
-	 * its parent below, because a subxact with XID < xmin has surely also got
-	 * a parent with XID < xmin, while one with XID >= xmax must belong to a
-	 * parent that was not yet committed at the time of this snapshot.
-	 */
-
-	/* Any xid < xmin is not in-progress */
-	if (TransactionIdPrecedes(xid, snapshot->xmin))
-		return false;
-	/* Any xid >= xmax is in-progress */
-	if (TransactionIdFollowsOrEquals(xid, snapshot->xmax))
-		return true;
+	*hintstatus = XID_INPROGRESS;
 
 	/*
-	 * Snapshot information is stored slightly differently in snapshots taken
-	 * during recovery.
+	 * Any xid >= xmax is in-progress (or aborted, but we don't distinguish
+	 * that here).
+	 *
+	 * We can't do anything useful with xmin, because the xmin only tells us
+	 * whether we see it as completed. We have to check the transaction log to
+	 * see if the transaction committed or aborted, in any case.
 	 */
-	if (!snapshot->takenDuringRecovery)
-	{
-		/*
-		 * If the snapshot contains full subxact data, the fastest way to
-		 * check things is just to compare the given XID against both subxact
-		 * XIDs and top-level XIDs.  If the snapshot overflowed, we have to
-		 * use pg_subtrans to convert a subxact XID to its parent XID, but
-		 * then we need only look at top-level XIDs not subxacts.
-		 */
-		if (!snapshot->suboverflowed)
-		{
-			/* we have full data, so search subxip */
-			int32		j;
+	if (TransactionIdFollowsOrEquals(xid, snapshot->xmax))
+		return false;
 
-			for (j = 0; j < snapshot->subxcnt; j++)
-			{
-				if (TransactionIdEquals(xid, snapshot->subxip[j]))
-					return true;
-			}
+	csn = TransactionIdGetCommitSeqNo(xid);
 
-			/* not there, fall through to search xip[] */
-		}
+	if (COMMITSEQNO_IS_COMMITTED(csn))
+	{
+		*hintstatus = XID_COMMITTED;
+		if (csn < snapshot->snapshotcsn)
+			return true;
 		else
-		{
-			/*
-			 * Snapshot overflowed, so convert xid to top-level.  This is safe
-			 * because we eliminated too-old XIDs above.
-			 */
-			xid = SubTransGetTopmostTransaction(xid);
-
-			/*
-			 * If xid was indeed a subxact, we might now have an xid < xmin,
-			 * so recheck to avoid an array scan.  No point in rechecking
-			 * xmax.
-			 */
-			if (TransactionIdPrecedes(xid, snapshot->xmin))
-				return false;
-		}
-
-		for (i = 0; i < snapshot->xcnt; i++)
-		{
-			if (TransactionIdEquals(xid, snapshot->xip[i]))
-				return true;
-		}
+			return false;
 	}
 	else
 	{
-		int32		j;
+		if (csn == COMMITSEQNO_ABORTED)
+			*hintstatus = XID_ABORTED;
+		return false;
+	}
+}
 
-		/*
-		 * In recovery we store all xids in the subxact array because it is by
-		 * far the bigger array, and we mostly don't know which xids are
-		 * top-level and which are subxacts. The xip array is empty.
-		 *
-		 * We start by searching subtrans, if we overflowed.
-		 */
-		if (snapshot->suboverflowed)
-		{
-			/*
-			 * Snapshot overflowed, so convert xid to top-level.  This is safe
-			 * because we eliminated too-old XIDs above.
-			 */
-			xid = SubTransGetTopmostTransaction(xid);
+/*
+ * CommittedXidVisibleInSnapshot
+ *		Is the given XID visible according to the snapshot?
+ *
+ * This is the same as XidVisibleInSnapshot, but the caller knows that the
+ * given XID committed. The only question is whether it's visible to our
+ * snapshot or not.
+ */
+static bool
+CommittedXidVisibleInSnapshot(TransactionId xid, Snapshot snapshot)
+{
+	CommitSeqNo csn;
 
-			/*
-			 * If xid was indeed a subxact, we might now have an xid < xmin,
-			 * so recheck to avoid an array scan.  No point in rechecking
-			 * xmax.
-			 */
-			if (TransactionIdPrecedes(xid, snapshot->xmin))
-				return false;
-		}
+	/*
+	 * Make a quick range check to eliminate most XIDs without looking at the
+	 * CSN log.
+	 */
+	if (TransactionIdPrecedes(xid, snapshot->xmin))
+		return true;
+
+	/*
+	 * Any xid >= xmax is in-progress (or aborted, but we don't distinguish
+	 * that here.
+	 */
+	if (TransactionIdFollowsOrEquals(xid, snapshot->xmax))
+		return false;
+
+	csn = TransactionIdGetCommitSeqNo(xid);
 
+	if (!COMMITSEQNO_IS_COMMITTED(csn))
+	{
+		elog(WARNING, "transaction %u was hinted as committed, but was not marked as committed in the transaction log", xid);
 		/*
-		 * We now have either a top-level xid higher than xmin or an
-		 * indeterminate xid. We don't know whether it's top level or subxact
-		 * but it doesn't matter. If it's present, the xid is visible.
+		 * We have contradicting evidence on whether the transaction committed or
+		 * not. Let's assume that it did. That seems better than erroring out.
 		 */
-		for (j = 0; j < snapshot->subxcnt; j++)
-		{
-			if (TransactionIdEquals(xid, snapshot->subxip[j]))
-				return true;
-		}
+		return true;
 	}
 
-	return false;
+	if (csn < snapshot->snapshotcsn)
+		return true;
+	else
+		return false;
 }
 
+
 /*
  * Is the tuple really only locked?  That is, is it not updated?
  *
@@ -1607,6 +1404,7 @@ bool
 HeapTupleHeaderIsOnlyLocked(HeapTupleHeader tuple)
 {
 	TransactionId xmax;
+	TransactionIdStatus	xidstatus;
 
 	/* if there's no valid Xmax, then there's obviously no update either */
 	if (tuple->t_infomask & HEAP_XMAX_INVALID)
@@ -1634,9 +1432,11 @@ HeapTupleHeaderIsOnlyLocked(HeapTupleHeader tuple)
 
 	if (TransactionIdIsCurrentTransactionId(xmax))
 		return false;
-	if (TransactionIdIsInProgress(xmax))
+
+	xidstatus = TransactionIdGetStatus(xmax);
+	if (xidstatus == XID_INPROGRESS)
 		return false;
-	if (TransactionIdDidCommit(xmax))
+	if (xidstatus == XID_COMMITTED)
 		return false;
 
 	/*
@@ -1677,6 +1477,7 @@ HeapTupleSatisfiesHistoricMVCC(HeapTuple htup, Snapshot snapshot,
 	HeapTupleHeader tuple = htup->t_data;
 	TransactionId xmin = HeapTupleHeaderGetXmin(tuple);
 	TransactionId xmax = HeapTupleHeaderGetRawXmax(tuple);
+	TransactionIdStatus hintstatus;
 
 	Assert(ItemPointerIsValid(&htup->t_self));
 	Assert(htup->t_tableOid != InvalidOid);
@@ -1688,7 +1489,7 @@ HeapTupleSatisfiesHistoricMVCC(HeapTuple htup, Snapshot snapshot,
 		return false;
 	}
 	/* check if it's one of our txids, toplevel is also in there */
-	else if (TransactionIdInArray(xmin, snapshot->subxip, snapshot->subxcnt))
+	else if (TransactionIdInArray(xmin, snapshot->this_xip, snapshot->this_xcnt))
 	{
 		bool		resolved;
 		CommandId	cmin = HeapTupleHeaderGetRawCommandId(tuple);
@@ -1699,7 +1500,8 @@ HeapTupleSatisfiesHistoricMVCC(HeapTuple htup, Snapshot snapshot,
 		 * cmin/cmax was stored in a combocid. So we need to lookup the actual
 		 * values externally.
 		 */
-		resolved = ResolveCminCmaxDuringDecoding(HistoricSnapshotGetTupleCids(), snapshot,
+		resolved = ResolveCminCmaxDuringDecoding(HistoricSnapshotGetTupleCids(),
+												 snapshot,
 												 htup, buffer,
 												 &cmin, &cmax);
 
@@ -1712,34 +1514,11 @@ HeapTupleSatisfiesHistoricMVCC(HeapTuple htup, Snapshot snapshot,
 			return false;		/* inserted after scan started */
 		/* fall through */
 	}
-	/* committed before our xmin horizon. Do a normal visibility check. */
-	else if (TransactionIdPrecedes(xmin, snapshot->xmin))
-	{
-		Assert(!(HeapTupleHeaderXminCommitted(tuple) &&
-				 !TransactionIdDidCommit(xmin)));
-
-		/* check for hint bit first, consult clog afterwards */
-		if (!HeapTupleHeaderXminCommitted(tuple) &&
-			!TransactionIdDidCommit(xmin))
-			return false;
-		/* fall through */
-	}
-	/* beyond our xmax horizon, i.e. invisible */
-	else if (TransactionIdFollowsOrEquals(xmin, snapshot->xmax))
-	{
-		return false;
-	}
-	/* check if it's a committed transaction in [xmin, xmax) */
-	else if (TransactionIdInArray(xmin, snapshot->xip, snapshot->xcnt))
-	{
-		/* fall through */
-	}
-
 	/*
-	 * none of the above, i.e. between [xmin, xmax) but hasn't committed. I.e.
-	 * invisible.
+	 * it's not "this" transaction. Do a normal visibility check using the
+	 * snapshot.
 	 */
-	else
+	else if (!XidVisibleInSnapshot(xmin, snapshot, &hintstatus))
 	{
 		return false;
 	}
@@ -1763,14 +1542,15 @@ HeapTupleSatisfiesHistoricMVCC(HeapTuple htup, Snapshot snapshot,
 	}
 
 	/* check if it's one of our txids, toplevel is also in there */
-	if (TransactionIdInArray(xmax, snapshot->subxip, snapshot->subxcnt))
+	if (TransactionIdInArray(xmax, snapshot->this_xip, snapshot->this_xcnt))
 	{
 		bool		resolved;
 		CommandId	cmin;
 		CommandId	cmax = HeapTupleHeaderGetRawCommandId(tuple);
 
 		/* Lookup actual cmin/cmax values */
-		resolved = ResolveCminCmaxDuringDecoding(HistoricSnapshotGetTupleCids(), snapshot,
+		resolved = ResolveCminCmaxDuringDecoding(HistoricSnapshotGetTupleCids(),
+												 snapshot,
 												 htup, buffer,
 												 &cmin, &cmax);
 
@@ -1784,26 +1564,74 @@ HeapTupleSatisfiesHistoricMVCC(HeapTuple htup, Snapshot snapshot,
 		else
 			return false;		/* deleted before scan started */
 	}
-	/* below xmin horizon, normal transaction state is valid */
-	else if (TransactionIdPrecedes(xmax, snapshot->xmin))
-	{
-		Assert(!(tuple->t_infomask & HEAP_XMAX_COMMITTED &&
-				 !TransactionIdDidCommit(xmax)));
+	/*
+	 * it's not "this" transaction. Do a normal visibility check using the
+	 * snapshot.
+	 */
+	if (XidVisibleInSnapshot(xmax, snapshot, &hintstatus))
+		return false;
+	else
+		return true;
+}
 
-		/* check hint bit first */
-		if (tuple->t_infomask & HEAP_XMAX_COMMITTED)
-			return false;
 
-		/* check clog */
-		return !TransactionIdDidCommit(xmax);
+/*
+ * Check the visibility on a tuple with HEAP_MOVED flags set.
+ *
+ * Returns true if the tuple is visible, false otherwise. These flags are
+ * no longer used, any such tuples must've come from binary upgrade of a
+ * pre-9.0 system, so we can assume that the xid is long finished by now.
+ */
+static bool
+IsMovedTupleVisible(HeapTuple htup, Buffer buffer)
+{
+	HeapTupleHeader tuple = htup->t_data;
+	TransactionId xvac = HeapTupleHeaderGetXvac(tuple);
+	TransactionIdStatus xidstatus;
+
+	/*
+	 * Check that the xvac is not a live transaction. This should never
+	 * happen, because HEAP_MOVED flags are not set by current code.
+	 */
+	if (TransactionIdIsCurrentTransactionId(xvac))
+		elog(ERROR, "HEAP_MOVED tuple with in-progress xvac: %u", xvac);
+
+	xidstatus = TransactionIdGetStatus(xvac);
+
+	if (tuple->t_infomask & HEAP_MOVED_OFF)
+	{
+		if (xidstatus == XID_COMMITTED)
+		{
+			SetHintBits(tuple, buffer, HEAP_XMIN_INVALID,
+						InvalidTransactionId);
+			return false;
+		}
+		else
+		{
+			SetHintBits(tuple, buffer, HEAP_XMIN_COMMITTED,
+						InvalidTransactionId);
+			return true;
+		}
+	}
+	/* Used by pre-9.0 binary upgrades */
+	else if (tuple->t_infomask & HEAP_MOVED_IN)
+	{
+		if (xidstatus == XID_COMMITTED)
+		{
+			SetHintBits(tuple, buffer, HEAP_XMIN_COMMITTED,
+						InvalidTransactionId);
+			return true;
+		}
+		else
+		{
+			SetHintBits(tuple, buffer, HEAP_XMIN_INVALID,
+						InvalidTransactionId);
+			return false;
+		}
 	}
-	/* above xmax horizon, we cannot possibly see the deleting transaction */
-	else if (TransactionIdFollowsOrEquals(xmax, snapshot->xmax))
-		return true;
-	/* xmax is between [xmin, xmax), check known committed array */
-	else if (TransactionIdInArray(xmax, snapshot->xip, snapshot->xcnt))
-		return false;
-	/* xmax is between [xmin, xmax), but known not to have committed yet */
 	else
-		return true;
+	{
+		elog(ERROR, "IsMovedTupleVisible() called on a non-moved tuple");
+		return true; /* keep compiler quiet */
+	}
 }
diff --git a/src/bin/initdb/initdb.c b/src/bin/initdb/initdb.c
index 9d1e5d789f..e6dae3ddae 100644
--- a/src/bin/initdb/initdb.c
+++ b/src/bin/initdb/initdb.c
@@ -198,12 +198,12 @@ static const char *backend_options = "--single -F -O -j -c search_path=pg_catalo
 static const char *const subdirs[] = {
 	"global",
 	"pg_wal/archive_status",
+	"pg_csnlog",
 	"pg_commit_ts",
 	"pg_dynshmem",
 	"pg_notify",
 	"pg_serial",
 	"pg_snapshots",
-	"pg_subtrans",
 	"pg_twophase",
 	"pg_multixact",
 	"pg_multixact/members",
diff --git a/src/include/access/clog.h b/src/include/access/clog.h
index 7bae0902b5..0755ffd864 100644
--- a/src/include/access/clog.h
+++ b/src/include/access/clog.h
@@ -17,16 +17,19 @@
 /*
  * Possible transaction statuses --- note that all-zeroes is the initial
  * state.
- *
- * A "subcommitted" transaction is a committed subtransaction whose parent
- * hasn't committed or aborted yet.
  */
-typedef int XidStatus;
+typedef int CLogXidStatus;
+
+#define CLOG_XID_STATUS_IN_PROGRESS		0x00
+#define CLOG_XID_STATUS_COMMITTED		0x01
+#define CLOG_XID_STATUS_ABORTED			0x02
 
-#define TRANSACTION_STATUS_IN_PROGRESS		0x00
-#define TRANSACTION_STATUS_COMMITTED		0x01
-#define TRANSACTION_STATUS_ABORTED			0x02
-#define TRANSACTION_STATUS_SUB_COMMITTED	0x03
+/*
+ * A "subcommitted" transaction is a committed subtransaction whose parent
+ * hasn't committed or aborted yet. We don't create these anymore, but accept
+ * them in existing clog, if we've been pg_upgraded from an older version.
+ */
+#define CLOG_XID_STATUS_SUB_COMMITTED	0x03
 
 typedef struct xl_clog_truncate
 {
@@ -35,9 +38,9 @@ typedef struct xl_clog_truncate
 	Oid			oldestXactDb;
 } xl_clog_truncate;
 
-extern void TransactionIdSetTreeStatus(TransactionId xid, int nsubxids,
-						   TransactionId *subxids, XidStatus status, XLogRecPtr lsn);
-extern XidStatus TransactionIdGetStatus(TransactionId xid, XLogRecPtr *lsn);
+extern void CLogSetTreeStatus(TransactionId xid, int nsubxids,
+				  TransactionId *subxids, CLogXidStatus status, XLogRecPtr lsn);
+extern CLogXidStatus CLogGetStatus(TransactionId xid, XLogRecPtr *lsn);
 
 extern Size CLOGShmemBuffers(void);
 extern Size CLOGShmemSize(void);
diff --git a/src/include/access/csnlog.h b/src/include/access/csnlog.h
new file mode 100644
index 0000000000..165effbee6
--- /dev/null
+++ b/src/include/access/csnlog.h
@@ -0,0 +1,33 @@
+/*
+ * csnlog.h
+ *
+ * Commit-Sequence-Number log.
+ *
+ * Portions Copyright (c) 1996-2014, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/include/access/clog.h
+ */
+#ifndef CSNLOG_H
+#define CSNLOG_H
+
+#include "access/xlog.h"
+
+extern void CSNLogSetCommitSeqNo(TransactionId xid, int nsubxids,
+					 TransactionId *subxids, CommitSeqNo csn);
+extern CommitSeqNo CSNLogGetCommitSeqNo(TransactionId xid);
+extern TransactionId CSNLogGetNextActiveXid(TransactionId start,
+											TransactionId end);
+
+extern Size CSNLOGShmemBuffers(void);
+extern Size CSNLOGShmemSize(void);
+extern void CSNLOGShmemInit(void);
+extern void BootStrapCSNLOG(void);
+extern void StartupCSNLOG(TransactionId oldestActiveXID);
+extern void TrimCSNLOG(void);
+extern void ShutdownCSNLOG(void);
+extern void CheckPointCSNLOG(void);
+extern void ExtendCSNLOG(TransactionId newestXact);
+extern void TruncateCSNLOG(TransactionId oldestXact);
+
+#endif   /* CSNLOG_H */
diff --git a/src/include/access/mvccvars.h b/src/include/access/mvccvars.h
new file mode 100644
index 0000000000..66de5a8ea6
--- /dev/null
+++ b/src/include/access/mvccvars.h
@@ -0,0 +1,86 @@
+/*-------------------------------------------------------------------------
+ *
+ * mvccvars.h
+ *	  Shared memory variables for XID assignment and snapshots
+ *
+ *
+ * Portions Copyright (c) 1996-2016, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/include/access/mvccvars.h
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifndef MVCCVARS_H
+#define MVCCVARS_H
+
+#include "port/atomics.h"
+
+/*
+ * VariableCache is a data structure in shared memory that is used to track
+ * OID and XID assignment state.  For largely historical reasons, there is
+ * just one struct with different fields that are protected by different
+ * LWLocks.
+ *
+ * Note: xidWrapLimit and oldestXidDB are not "active" values, but are
+ * used just to generate useful messages when xidWarnLimit or xidStopLimit
+ * are exceeded.
+ */
+typedef struct VariableCacheData
+{
+	/*
+	 * These fields are protected by OidGenLock.
+	 */
+	Oid			nextOid;		/* next OID to assign */
+	uint32		oidCount;		/* OIDs available before must do XLOG work */
+
+	/*
+	 * These fields are protected by XidGenLock.
+	 */
+	TransactionId nextXid;		/* next XID to assign */
+
+	TransactionId oldestXid;	/* cluster-wide minimum datfrozenxid */
+	TransactionId xidVacLimit;	/* start forcing autovacuums here */
+	TransactionId xidWarnLimit; /* start complaining here */
+	TransactionId xidStopLimit; /* refuse to advance nextXid beyond here */
+	TransactionId xidWrapLimit; /* where the world ends */
+	Oid			oldestXidDB;	/* database with minimum datfrozenxid */
+
+
+	/*
+	 * Fields related to MVCC snapshots.
+	 *
+	 * lastCommitSeqNo is the CSN assigned to last committed transaction.
+	 * It is protected by CommitSeqNoLock.
+	 *
+	 * latestCompletedXid is the highest XID that has committed. Anything
+	 * > this is seen by still in-progress by everyone. Use atomic ops to
+	 * update.
+	 *
+	 * oldestActiveXid is the XID of the oldest transaction that's still
+	 * in-progress. (Or rather, the oldest XID among all still in-progress
+	 * transactions; it's not necessarily the one that started first).
+	 * Must hold ProcArrayLock in shared mode, and use atomic ops, to update.
+	 */
+	pg_atomic_uint64 nextCommitSeqNo;
+	pg_atomic_uint32 latestCompletedXid;
+	pg_atomic_uint32 oldestActiveXid;
+
+	/*
+	 * These fields are protected by CommitTsLock
+	 */
+	TransactionId oldestCommitTsXid;
+	TransactionId newestCommitTsXid;
+
+	/*
+	 * These fields are protected by CLogTruncationLock
+	 */
+	TransactionId oldestClogXid;	/* oldest it's safe to look up in clog */
+} VariableCacheData;
+
+typedef VariableCacheData *VariableCache;
+
+/* in transam/varsup.c */
+extern PGDLLIMPORT VariableCache ShmemVariableCache;
+
+#endif   /* MVCCVARS_H */
diff --git a/src/include/access/slru.h b/src/include/access/slru.h
index d829a6fab4..1d38423cfc 100644
--- a/src/include/access/slru.h
+++ b/src/include/access/slru.h
@@ -105,6 +105,8 @@ typedef struct SlruSharedData
 } SlruSharedData;
 
 typedef SlruSharedData *SlruShared;
+typedef struct HTAB HTAB;
+typedef struct PageSlotEntry PageSlotEntry;
 
 /*
  * SlruCtlData is an unshared structure that points to the active information
@@ -113,6 +115,7 @@ typedef SlruSharedData *SlruShared;
 typedef struct SlruCtlData
 {
 	SlruShared	shared;
+	HTAB *pageToSlot;
 
 	/*
 	 * This flag tells whether to fsync writes (true for pg_xact and multixact
@@ -145,6 +148,8 @@ extern int SimpleLruReadPage(SlruCtl ctl, int pageno, bool write_ok,
 				  TransactionId xid);
 extern int SimpleLruReadPage_ReadOnly(SlruCtl ctl, int pageno,
 						   TransactionId xid);
+extern int SimpleLruReadPage_ReadOnly_Locked(SlruCtl ctl, int pageno,
+						   TransactionId xid);
 extern void SimpleLruWritePage(SlruCtl ctl, int slotno);
 extern void SimpleLruFlush(SlruCtl ctl, bool allow_redirtied);
 extern void SimpleLruTruncate(SlruCtl ctl, int cutoffPage);
diff --git a/src/include/access/subtrans.h b/src/include/access/subtrans.h
index 41716d7b71..92267be465 100644
--- a/src/include/access/subtrans.h
+++ b/src/include/access/subtrans.h
@@ -11,20 +11,9 @@
 #ifndef SUBTRANS_H
 #define SUBTRANS_H
 
-/* Number of SLRU buffers to use for subtrans */
-#define NUM_SUBTRANS_BUFFERS	32
-
+/* these are in csnlog.c now */
 extern void SubTransSetParent(TransactionId xid, TransactionId parent);
 extern TransactionId SubTransGetParent(TransactionId xid);
 extern TransactionId SubTransGetTopmostTransaction(TransactionId xid);
 
-extern Size SUBTRANSShmemSize(void);
-extern void SUBTRANSShmemInit(void);
-extern void BootStrapSUBTRANS(void);
-extern void StartupSUBTRANS(TransactionId oldestActiveXID);
-extern void ShutdownSUBTRANS(void);
-extern void CheckPointSUBTRANS(void);
-extern void ExtendSUBTRANS(TransactionId newestXact);
-extern void TruncateSUBTRANS(TransactionId oldestXact);
-
-#endif							/* SUBTRANS_H */
+#endif   /* SUBTRANS_H */
diff --git a/src/include/access/transam.h b/src/include/access/transam.h
index 86076dede1..7a3839ce19 100644
--- a/src/include/access/transam.h
+++ b/src/include/access/transam.h
@@ -93,57 +93,6 @@
 #define FirstBootstrapObjectId	10000
 #define FirstNormalObjectId		16384
 
-/*
- * VariableCache is a data structure in shared memory that is used to track
- * OID and XID assignment state.  For largely historical reasons, there is
- * just one struct with different fields that are protected by different
- * LWLocks.
- *
- * Note: xidWrapLimit and oldestXidDB are not "active" values, but are
- * used just to generate useful messages when xidWarnLimit or xidStopLimit
- * are exceeded.
- */
-typedef struct VariableCacheData
-{
-	/*
-	 * These fields are protected by OidGenLock.
-	 */
-	Oid			nextOid;		/* next OID to assign */
-	uint32		oidCount;		/* OIDs available before must do XLOG work */
-
-	/*
-	 * These fields are protected by XidGenLock.
-	 */
-	TransactionId nextXid;		/* next XID to assign */
-
-	TransactionId oldestXid;	/* cluster-wide minimum datfrozenxid */
-	TransactionId xidVacLimit;	/* start forcing autovacuums here */
-	TransactionId xidWarnLimit; /* start complaining here */
-	TransactionId xidStopLimit; /* refuse to advance nextXid beyond here */
-	TransactionId xidWrapLimit; /* where the world ends */
-	Oid			oldestXidDB;	/* database with minimum datfrozenxid */
-
-	/*
-	 * These fields are protected by CommitTsLock
-	 */
-	TransactionId oldestCommitTsXid;
-	TransactionId newestCommitTsXid;
-
-	/*
-	 * These fields are protected by ProcArrayLock.
-	 */
-	TransactionId latestCompletedXid;	/* newest XID that has committed or
-										 * aborted */
-
-	/*
-	 * These fields are protected by CLogTruncationLock
-	 */
-	TransactionId oldestClogXid;	/* oldest it's safe to look up in clog */
-
-} VariableCacheData;
-
-typedef VariableCacheData *VariableCache;
-
 
 /* ----------------
  *		extern declarations
@@ -153,15 +102,44 @@ typedef VariableCacheData *VariableCache;
 /* in transam/xact.c */
 extern bool TransactionStartedDuringRecovery(void);
 
-/* in transam/varsup.c */
-extern PGDLLIMPORT VariableCache ShmemVariableCache;
-
 /*
  * prototypes for functions in transam/transam.c
  */
 extern bool TransactionIdDidCommit(TransactionId transactionId);
 extern bool TransactionIdDidAbort(TransactionId transactionId);
-extern bool TransactionIdIsKnownCompleted(TransactionId transactionId);
+
+
+#define COMMITSEQNO_INPROGRESS	UINT64CONST(0x0)
+#define COMMITSEQNO_ABORTED		UINT64CONST(0x1)
+/*
+ * COMMITSEQNO_COMMITING is an intermediate state that is used to set CSN
+ * atomically for a top level transaction and its subtransactions.
+ * High-level users should not see this value, see TransactionIdGetCommitSeqNo().
+ */
+#define COMMITSEQNO_COMMITTING	UINT64CONST(0x2)
+#define COMMITSEQNO_FROZEN		UINT64CONST(0x3)
+#define COMMITSEQNO_FIRST_NORMAL UINT64CONST(0x4)
+
+#define COMMITSEQNO_IS_INPROGRESS(csn) ((csn) == COMMITSEQNO_INPROGRESS)
+#define COMMITSEQNO_IS_ABORTED(csn) ((csn) == COMMITSEQNO_ABORTED)
+#define COMMITSEQNO_IS_FROZEN(csn) ((csn) == COMMITSEQNO_FROZEN)
+#define COMMITSEQNO_IS_NORMAL(csn) ((csn) >= COMMITSEQNO_FIRST_NORMAL)
+#define COMMITSEQNO_IS_COMMITTING(csn) ((csn) == COMMITSEQNO_COMMITTING)
+#define COMMITSEQNO_IS_COMMITTED(csn) ((csn) >= COMMITSEQNO_FROZEN && !COMMITSEQNO_IS_SUBTRANS(csn))
+
+#define CSN_SUBTRANS_BIT		(UINT64CONST(1)<<63)
+
+#define COMMITSEQNO_IS_SUBTRANS(csn) ((csn) & CSN_SUBTRANS_BIT)
+
+typedef enum
+{
+	XID_COMMITTED,
+	XID_ABORTED,
+	XID_INPROGRESS
+} TransactionIdStatus;
+
+extern CommitSeqNo TransactionIdGetCommitSeqNo(TransactionId xid);
+extern TransactionIdStatus TransactionIdGetStatus(TransactionId transactionId);
 extern void TransactionIdAbort(TransactionId transactionId);
 extern void TransactionIdCommitTree(TransactionId xid, int nxids, TransactionId *xids);
 extern void TransactionIdAsyncCommitTree(TransactionId xid, int nxids, TransactionId *xids, XLogRecPtr lsn);
diff --git a/src/include/access/xact.h b/src/include/access/xact.h
index f2c10f905f..72016ba377 100644
--- a/src/include/access/xact.h
+++ b/src/include/access/xact.h
@@ -135,7 +135,7 @@ typedef void (*SubXactCallback) (SubXactEvent event, SubTransactionId mySubid,
 #define XLOG_XACT_ABORT				0x20
 #define XLOG_XACT_COMMIT_PREPARED	0x30
 #define XLOG_XACT_ABORT_PREPARED	0x40
-#define XLOG_XACT_ASSIGNMENT		0x50
+/* free opcode 0x50 */
 /* free opcode 0x60 */
 /* free opcode 0x70 */
 
@@ -334,7 +334,6 @@ extern TransactionId GetCurrentTransactionId(void);
 extern TransactionId GetCurrentTransactionIdIfAny(void);
 extern TransactionId GetStableLatestTransactionId(void);
 extern SubTransactionId GetCurrentSubTransactionId(void);
-extern void MarkCurrentTransactionIdLoggedIfAny(void);
 extern bool SubTransactionIsActive(SubTransactionId subxid);
 extern CommandId GetCurrentCommandId(bool used);
 extern TimestampTz GetCurrentTransactionStartTimestamp(void);
diff --git a/src/include/access/xlog.h b/src/include/access/xlog.h
index 66bfb77295..c2f557e9c7 100644
--- a/src/include/access/xlog.h
+++ b/src/include/access/xlog.h
@@ -52,11 +52,6 @@ extern bool InRecovery;
  * we haven't yet processed a RUNNING_XACTS or shutdown-checkpoint WAL record
  * to initialize our master-transaction tracking system.
  *
- * When the transaction tracking is initialized, we enter the SNAPSHOT_PENDING
- * state. The tracked information might still be incomplete, so we can't allow
- * connections yet, but redo functions must update the in-memory state when
- * appropriate.
- *
  * In SNAPSHOT_READY mode, we have full knowledge of transactions that are
  * (or were) running in the master at the current WAL location. Snapshots
  * can be taken, and read-only queries can be run.
@@ -65,13 +60,12 @@ typedef enum
 {
 	STANDBY_DISABLED,
 	STANDBY_INITIALIZED,
-	STANDBY_SNAPSHOT_PENDING,
 	STANDBY_SNAPSHOT_READY
 } HotStandbyState;
 
 extern HotStandbyState standbyState;
 
-#define InHotStandby (standbyState >= STANDBY_SNAPSHOT_PENDING)
+#define InHotStandby (standbyState >= STANDBY_SNAPSHOT_READY)
 
 /*
  * Recovery target type.
diff --git a/src/include/c.h b/src/include/c.h
index 630dfbfc41..3e4ebda3c8 100644
--- a/src/include/c.h
+++ b/src/include/c.h
@@ -410,6 +410,13 @@ typedef uint32 CommandId;
 #define InvalidCommandId	(~(CommandId)0)
 
 /*
+ * CommitSeqNo is currently an LSN, but keep use a separate datatype for clarity.
+ */
+typedef uint64 CommitSeqNo;
+
+#define InvalidCommitSeqNo		((CommitSeqNo) 0)
+
+/*
  * Array indexing support
  */
 #define MAXDIM 6
diff --git a/src/include/catalog/pg_proc.h b/src/include/catalog/pg_proc.h
index d820b56aa1..618d2a0501 100644
--- a/src/include/catalog/pg_proc.h
+++ b/src/include/catalog/pg_proc.h
@@ -5086,8 +5086,6 @@ DATA(insert OID = 2945 (  txid_snapshot_xmin		PGNSP PGUID 12 1  0 0 0 f f f f t
 DESCR("get xmin of snapshot");
 DATA(insert OID = 2946 (  txid_snapshot_xmax		PGNSP PGUID 12 1  0 0 0 f f f f t f i s 1 0 20 "2970" _null_ _null_ _null_ _null_ _null_ txid_snapshot_xmax _null_ _null_ _null_ ));
 DESCR("get xmax of snapshot");
-DATA(insert OID = 2947 (  txid_snapshot_xip			PGNSP PGUID 12 1 50 0 0 f f f f t t i s 1 0 20 "2970" _null_ _null_ _null_ _null_ _null_ txid_snapshot_xip _null_ _null_ _null_ ));
-DESCR("get set of in-progress txids in snapshot");
 DATA(insert OID = 2948 (  txid_visible_in_snapshot	PGNSP PGUID 12 1  0 0 0 f f f f t f i s 2 0 16 "20 2970" _null_ _null_ _null_ _null_ _null_ txid_visible_in_snapshot _null_ _null_ _null_ ));
 DESCR("is txid visible in snapshot?");
 DATA(insert OID = 3360 (  txid_status				PGNSP PGUID 12 1  0 0 0 f f f f t f v s 1 0 25 "20" _null_ _null_ _null_ _null_ _null_ txid_status _null_ _null_ _null_ ));
diff --git a/src/include/replication/snapbuild.h b/src/include/replication/snapbuild.h
index 7653717f83..6e93a9033f 100644
--- a/src/include/replication/snapbuild.h
+++ b/src/include/replication/snapbuild.h
@@ -20,30 +20,14 @@ typedef enum
 	/*
 	 * Initial state, we can't do much yet.
 	 */
-	SNAPBUILD_START = -1,
+	SNAPBUILD_START,
 
 	/*
-	 * Collecting committed transactions, to build the initial catalog
-	 * snapshot.
+	 * Found a point after hitting built_full_snapshot where all transactions
+	 * that were running at that point finished. Till we reach that we hold
+	 * off calling any commit callbacks.
 	 */
-	SNAPBUILD_BUILDING_SNAPSHOT = 0,
-
-	/*
-	 * We have collected enough information to decode tuples in transactions
-	 * that started after this.
-	 *
-	 * Once we reached this we start to collect changes. We cannot apply them
-	 * yet, because they might be based on transactions that were still
-	 * running when FULL_SNAPSHOT was reached.
-	 */
-	SNAPBUILD_FULL_SNAPSHOT = 1,
-
-	/*
-	 * Found a point after SNAPBUILD_FULL_SNAPSHOT where all transactions that
-	 * were running at that point finished. Till we reach that we hold off
-	 * calling any commit callbacks.
-	 */
-	SNAPBUILD_CONSISTENT = 2
+	SNAPBUILD_CONSISTENT
 } SnapBuildState;
 
 /* forward declare so we don't have to expose the struct to the public */
@@ -57,10 +41,8 @@ struct ReorderBuffer;
 struct xl_heap_new_cid;
 struct xl_running_xacts;
 
-extern void CheckPointSnapBuild(void);
-
 extern SnapBuild *AllocateSnapshotBuilder(struct ReorderBuffer *cache,
-						TransactionId xmin_horizon, XLogRecPtr start_lsn,
+						XLogRecPtr start_lsn,
 						bool need_full_snapshot);
 extern void FreeSnapshotBuilder(SnapBuild *cache);
 
@@ -85,6 +67,7 @@ extern void SnapBuildProcessNewCid(SnapBuild *builder, TransactionId xid,
 					   XLogRecPtr lsn, struct xl_heap_new_cid *cid);
 extern void SnapBuildProcessRunningXacts(SnapBuild *builder, XLogRecPtr lsn,
 							 struct xl_running_xacts *running);
-extern void SnapBuildSerializationPoint(SnapBuild *builder, XLogRecPtr lsn);
+extern void SnapBuildProcessInitialSnapshot(SnapBuild *builder, XLogRecPtr lsn,
+								TransactionId xmin, TransactionId xmax);
 
 #endif							/* SNAPBUILD_H */
diff --git a/src/include/storage/lwlock.h b/src/include/storage/lwlock.h
index 3d16132c88..d491a0014c 100644
--- a/src/include/storage/lwlock.h
+++ b/src/include/storage/lwlock.h
@@ -197,7 +197,7 @@ typedef enum BuiltinTrancheIds
 {
 	LWTRANCHE_CLOG_BUFFERS = NUM_INDIVIDUAL_LWLOCKS,
 	LWTRANCHE_COMMITTS_BUFFERS,
-	LWTRANCHE_SUBTRANS_BUFFERS,
+	LWTRANCHE_CSNLOG_BUFFERS,
 	LWTRANCHE_MXACTOFFSET_BUFFERS,
 	LWTRANCHE_MXACTMEMBER_BUFFERS,
 	LWTRANCHE_ASYNC_BUFFERS,
